stages:
  - introduce
  - build
  - deploy staging
  - deploy development
  - deploy prod

  
introduce:
  stage: introduce
  tags:
    - linux
  script:
    - echo "Greetings  you, $GITLAB_USER_LOGIN!"
  

build:
  stage: build
  tags:
    - linux
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD
  script:
    - echo "This level about build a single docker container using NGINX image and pushing him to dockerhub"
    - docker build -t "$CI_REGISTRY_USER"/"$CI_REGISTRY_IMAGE":latest .
    - docker push $CI_REGISTRY_USER/$CI_REGISTRY_IMAGE:latest


deploy staging:
  stage: deploy staging
  environment: staging
  tags:
    - linux
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD"
  script:
    - echo -e "This level will do a couple of things:\n1. Build NGINX Image\n2. Push him to dockerhub\n3. Deploy a single container "
    - docker stop $(docker ps -aq)
    - docker rm $(docker ps -aq)
    - docker rmi -f $(docker images -q)
    - docker build -t $CI_REGISTRY_USER/$CI_REGISTRY_IMAGE:staging .
    - docker push $CI_REGISTRY_USER/$CI_REGISTRY_IMAGE:staging
    - docker run -d -p 8080:80 --name simple_container $CI_REGISTRY_USER/$CI_REGISTRY_IMAGE:staging
  only:
    - /^v(\d+\.)?(\d+\.)?(\*|\d+)-st$/

deploy development:
  stage: deploy development
  tags:
    - linux
  environment: development
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD
  script:
    - echo -e "This level will do a couple of things:\n1. Build NGINX Image with enviroment variable\n2. Push him to dockerhub\n3. Deploy a single container "
    - docker stop $(docker ps -aq)
    - docker rm $(docker ps -aq)
    - docker rmi -f $(docker images -q)
    - sed -i s/works/${CI_ENVIRONMENT_NAME}/ index.html    
    - docker build -t $CI_REGISTRY_USER/$CI_REGISTRY_IMAGE:dev .
    - docker push $CI_REGISTRY_USER/$CI_REGISTRY_IMAGE:dev
    - docker run -d -p 8080:80 --name simple_container $CI_REGISTRY_USER/$CI_REGISTRY_IMAGE:dev
  only:
    - /^v(\d+\.)?(\d+\.)?(\*|\d+)-dev$/


deploy prod:
  stage: deploy prod
  environment: production
  tags:
    - linux
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD
  script:
    - echo -e "This level will do a couple of things:\n1. Build NGINX Image with enviroment variable\n2. Push him to dockerhub\n3. Deploy a single container\n4. Stole some secrets "
    - docker stop $(docker ps -aq)
    - docker rm $(docker ps -aq)
    - docker rmi -f $(docker images -q)
    - sed -i s/works/${CI_ENVIRONMENT_NAME}/ index.html    
    - docker build -t $CI_REGISTRY_USER/$CI_REGISTRY_IMAGE:prod .
    - docker push $CI_REGISTRY_USER/$CI_REGISTRY_IMAGE:prod
    - docker run -d -p 8080:80 --name simple_container $CI_REGISTRY_USER/$CI_REGISTRY_IMAGE:prod
  after_script:
    - echo "Secret stuff" > secret.txt
  artifacts:
    paths:
      - secret.txt
    expire_in: 1 day

  only:
    - /^v(\d+\.)?(\d+\.)?(\*|\d+)$/
